#!/usr/bin/python3

import glob
import os
import shutil
import subprocess
import time

#BASEDEST = "/home/facundo/sistema/remote-data/fotos/"
BASEDEST = "/home/facundo/sistema/fotos/"


def crea_dir():
    newdir = time.strftime("%Y%m%d%H%M%S")
    destin = os.path.join(BASEDEST, newdir)
    print("Creando el directorio %r" % destin)
    os.mkdir(destin)
    return destin


def get_fuji(origen):
    destin = crea_dir()

    # tomamos los dirs
    archs = os.listdir(origen)
    for arch in archs:
        orig = os.path.join(origen, arch)
        dest = os.path.join(destin, "DSF6" + arch[4:])
        shutil.copy2(orig, dest)
        print(orig, dest)

    print("Todo en:", destin)


def get_canon():
    # creamos el new dir y vamos
    newdir = crea_dir()
    os.chdir(newdir)

    # traemos todo. Nota: no conviene traer de a uno usando gphoto2 desde linea
    # de comando, porque para cada llamada hay toda una inicialización de
    # la cámara
    subprocess.run(["gphoto2", "--get-all-files"])

    # renombramos
    archivos = glob.glob("IMG*.JPG")
    archivos.extend(glob.glob("IMG*.MVI"))
    archivos.extend(glob.glob("MVI*.MOV"))
    archivos.extend(glob.glob("MVI*.MP4"))
    print("Renombrando %d archivos..." % len(archivos))
    for oldname in archivos:
        newname = "%s8%s" % tuple(oldname.split("_"))
        os.rename(oldname, newname)

    print("Todo en:", newdir)


def main():
    # vemos si está la FUJI
    fuji_path = "/media/disk/DCIM/103_FUJI/"
    if os.path.exists(fuji_path):
        print("Encontrada la Fuji en", fuji_path)
        get_fuji(fuji_path)
        return

    # vemos si está la Canon
    proc = subprocess.run(["gphoto2", "--auto-detect"], capture_output=True, encoding='utf8')
    for lin in proc.stdout.split('\n'):
        canon = ("USB PTP Class Camera", "Canon PowerShot", "Canon EOS 7D")
        if any(lin.startswith(x) for x in canon):
            print("Encontrada la", lin)
            get_canon()
            return

    # oops
    print("No se encontró ninguna cámara conectada!")


if __name__ == "__main__":
    if not os.path.exists(BASEDEST):
        print("ERROR: cannot access", BASEDEST)
    main()
